TestCase('ValidateTest', {
  setUp: function() {
    this.email = {value: 'venkats@agiledeveloper.com'};
    this.error = {innerHTML: ''}; 
    this.errorMessage = 'invalid email address provided!';
  },
  
  tearDown: function() {
    delete this.email;
    delete this.error;
  },
  
  "test canary": function() { assertTrue(true); },
  
  "test valid email": function() {
    validateEmail(this.email, this.error);
    
    assertEquals('', this.error.innerHTML);
  },
  
  "test email without @": function() {
    this.email.value = 'venkats';
    
    validateEmail(this.email, this.error);
    assertEquals(this.errorMessage, this.error.innerHTML);
  },
  
  "test error should clear when valid email address given": function() {
    this.email.value = 'venkats';
    
    validateEmail(this.email, this.error);
    this.email.value = 'venkats@agiledeveloper.com';
    validateEmail(this.email, this.error);
    assertEquals('', this.error.innerHTML);
  },
  
  "test on error set focus on email field": function() {
    this.email.value = 'venkats';
    this.email.id = 'emailid';
    var oldSetFocus = setFocus;
    
    var setFocusCalled = false;
    setFocus = function(elementid) {
      setFocusCalled = true;
      assertEquals("emailid", elementid);
    } 
    
    validateEmail(this.email, this.error);
    
    assertTrue(setFocusCalled);
    setFocus = oldSetFocus;
  }
});







